<?
 require_once($_path["include"]."data.php");

 class redirect extends BasePlugin
 {
  function main()
  {
   global $_jses, $_path;

   switch($this->plugin->config["method"])
   {
    case "Page":
    {
     $d=new Data("pager_categories", "view", "item");
     $d->setValue("nr", $this->plugin->config["page"]);
     $d->setShowFields("urlname");

     if($d->get()&&$d->next()&&$d->v["urlname"])
      $url=$d->v["urlname"];
     else
      $url=$this->plugin->config["page"];

     if($_jses["modRewriteActive"]) //mod rewrite
      $url=$_path["HTML"]["current"].$url."/";
     else
      $url=$_path["HTML"]["current"]."?p[]=".$url;

     break;
    }
    case "URL":
    {
     $url=$this->plugin->config["url"];
     break;
    }
    case "HTTP":
    case "HTTPS":
    {
     if(isset($_SERVER["HTTPS"])&&$_SERVER["HTTPS"]) //on HTTPS
     {
      //HTTPS requires secure coookie
      $params=session_get_cookie_params();

      if(!$params["secure"])
       session_set_cookie_params($params["lifetime"], $params["path"], $params["domain"], true);

      unset($params);

      if($this->plugin->config["method"]=="HTTP") //go to HTTP
       $url="http://".$_SERVER["HTTP_HOST"].$_SERVER["REQUEST_URI"];
      else
       return true; //no change required
     }
     else //on HTTP
     {
      if($this->plugin->config["method"]=="HTTPS") //go to HTTP
       $url="https://".$_SERVER["HTTP_HOST"].$_SERVER["REQUEST_URI"];
      else
       return true; //no change required
     }
         
     break;
    }
    default:
    {
     $this->e->add("Unknown redirection method: \"".$this->plugin->config["method"]."\"", "error");
     return false;
    }
   }

   if($this->plugin->config["type"]=="Header")
   {
    header("location: ".$url);
    exit;
   }
   else //JavaScript
   {
    $this->output="<script type=\"text/javascript\">setTimeout(\"this.location='".$url."'\", ".($this->plugin->config["delay"]*1000).");</script>\n";

    if($this->plugin->config["message"])
     $this->output.=str_replace("#url#", $url, str_replace("#delay#", $this->plugin->config["delay"], $this->plugin->config["message"]));
   }

   return true;
  }
 }
?>
